//龙族世界重制版
const skilllz = {
       //技能
       '技能石：星空' : new Element({
        battleUse : true,
        canUse : true,
        voidDust : 20,
        quality : 1,
        gold : 50,
        weight : 0,
        func : function(){
            if(!checkRace('星空', true)){
                return false;
            }
            hp = data.maxHp - data.hp;
            data.hp += hp
            const text = `星空照射，你回复了${hp}血量`;
            addBattleLog(text)
            winMsg(text)
            return true;
        },
        text : '恢复所有血量'
    }),
       '技能石：黄土守护' : new Element({
        battleUse : true,
        voidDust : 20,
        quality : 1,
        gold : 50,
        weight : 0,
        func : function(){
            if(!checkRace('黄土守护', true)){
                return false;
            }
            if(data.battleMonster.htsh){
                winMsg(`你已经使用过一次了`, false, false);
                return false;
            }
            data.battleMonster.htsh = true;
            data.reduceHart += 0.9999;
            const text = `使用黄土守护，获得99.99%减伤`;
            addBattleLog(text)
            return true;
        },
        text : '增加99.99%减伤，只能使用一次'
    }),
    '技能石：真灵呼唤' : new Element({
        battleUse : true,
        voidDust : 20,
        quality : 1,
        gold : 50,
        weight : 0,
        func : function(){
            if(!checkRace('真灵呼唤', true)){
                return false;
            }
            if(data.battleMonster.zlhh){
                winMsg(`你已经使用过一次了`, false, false);
                return false;
            }
            let l = data.level
            data.battleMonster.zlhh = true;
            data.maxHp *= l
            data.atk *= l
            data.def *= l
            data.hp *= l
            data.lzsjzlhh = true;
            const text = `真灵显现，你的血量，防御，攻击×${l}`;
            addBattleLog(text)
            return true;
        },
        text : '使用后攻击，防御，血量分别×当前等级，同时等级变为一并附带洗点，只能使用一次'
    }),
    '技能石：人剑合一' : new Element({
        battleUse : true,
        voidDust : 20,
        quality : 1,
        gold : 50,
        weight : 0,
        func : function(){
            if(!checkRace('人剑合一', true)){
                return false;
            }
            if(data.battleMonster.rjhy){
                winMsg(`你已经使用过一次了`, false, false);
                return false;
            }
            if(data.weapon.name !== '灵剑'){
                winMsg(`无剑无体`);
                return false;
            }
            data.battleMonster.rjhy = true;
            data.atk *= 999
            data.hp = 1
            data.maxHp = 1
            data.def = 1
            addStatus(data.battleMonster, getStatus('眩晕', {num : 1}));
            const text = `以剑为体，剑碎人灭，攻击×999，血量防御降为1`;
            addBattleLog(text)
            return true;
        },
        text : '使用后你的状态将和剑绑定，同时攻击×999，血量防御将为1，只能使用一次'
    }),
    '技能石：斩天' : new Element({
        battleUse : true,
        voidDust : 20,
        quality : 1,
        gold : 50,
        weight : 0,
        func : function(){
            if(!checkRace('斩天', true)){
                return false;
            }
            if(data.weapon.name !== '灵剑'){
                winMsg(`无剑不斩`)
                return false;
            }
            if(randomNum(1,2) <= 1){
            battleWin();
            }else{
            die();
            }
            const text = `斩杀成功`;
            winMsg(text)
            return true;
        },
        text : '使用后斩杀自我或敌人'
    }),
        '技能石：空间折叠' : new Element({
        canUse : true, 
        voidDust : 0, 
        gold : 0, 
        weight : 0, 
        func(item){
            if(!checkRace('空间折叠', true)){
                return false;
            }
            renderStore();
            $('.store').show();
            $('.item-use-win-close').click()
            return false;
        }, text : '龙-空间种族技能，使用后打开仓库页面，可以无限次数使用'}),
       '技能石：龙吟护盾' : new Element({
        battleUse : true,
        voidDust : 20,
        quality : 1,
        gold : 50,
        weight : 0,
        func : function(){
            if(!checkRace('龙吟护盾', true)){
                return false;
            }
            if(data.battleMonster.lyhd){
                winMsg(`你已经使用过一次了`, false, false);
                return false;
            }
            data.battleMonster.lyhd = true;
            data.reduceHart += 0.1;
            data.shield += data.maxHp * 0.5;
            const text = `使用了龙吟护盾，增加10%减伤，同时获得最大血量50%的护盾`;
            addBattleLog(text)
            return true;
        },
        text : '增加10%减伤，获得50%的护盾，只能使用一次'
    }),
    '技能石：时间回溯' : new Element({
        battleUse : true,
        voidDust : 0,
        quality : 1,
        gold : 0,
        weight : 0,
        func : function(){
            if(!checkRace('时间回溯', true)){
                return false;
            }
            battleEnd()
            data.hp = data.lzsjsjhshp;
            data.maxHp = data.lzsjsjhsmaxHp
            data.atk = data.lzsjsjhsatk
            data.def = data.lzsjsjhsdef
            data.suck = data.lzsjsjhssuck
            data.reduceHart = data.lzsjsjhsreduceHart
            data.evil = data.lzsjsjhsevil
            const text = `使用了时间回溯，回到了战斗开始的时候`;
            winMsg(text)
            return true;
        },
        text : '使用后将时间回溯到战斗开始之前'
    }),
    '技能石：时间之力' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 0,
        endurance : 100,
        noSuck : true,
        voidDust : 0,
        quality : 1,
        gold : 0,
        preFunc : function(){
            if(!checkRace('时间之力', true)){
                return false;
            }
            if(randomNum(1,2) <= 1){
            addStatus(data.battleMonster, getStatus('时间停止', {num : 1}));
            }
            return true;
        },
        myAtk : function(){
            return parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 5)
        },
        text : '龙-时间种族技能，攻击50%附带时间停止效果，伤害为攻击+武器攻击的5倍'
    }),
    '技能石：时空之力' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 0,
        endurance : 100,
        noSuck : true,
        voidDust : 0,
        quality : 1,
        gold : 0,
        preFunc : function(){
            if(!checkRace('时空之力', true)){
                return false;
            }
            if(randomNum(1,2) <= 2){
            addStatus(data.battleMonster, getStatus('封印', {num : 10}));
            addStatus(data.battleMonster, getStatus('眩晕', {num : 2}));
            addStatus(data.battleMonster, getStatus('流血', {num : 999,harm : data.atk}));
            }
            return true;
        },
        myAtk : function(){
            return parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 10)
        },
        text : '龙-时空种族技能，攻击100%附带封印，眩晕，流血效果，伤害为攻击+武器攻击的10倍'
    }),
    '技能石：空间之力' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 0,
        endurance : 100,
        noSuck : true,
        voidDust : 0,
        quality : 1,
        gold : 0,
        preFunc : function(){
            if(!checkRace('空间之力', true)){
                return false;
            }
            addStatus(data.battleMonster, getStatus('流血', {num : 100,harm : data.atk}));
            return true;
        },
        myAtk : function(){
            return parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 8)
        },
        text : '龙-空间种族技能，攻击100%附带流血效果，伤害为攻击+武器攻击的8倍'
    }),
    '技能石：星辰七连' : new Element({
        battleUse : true,
        voidDust : 0,
        quality : 2,
        gold : 0,
        weight : 0,
        func : function(){
            if(!checkRace('星辰七连', true)){
                return false;
            }
            if(randomNum(1,7) <= 1){
            let def = data.battleMonster.def * 0.5
            data.battleMonster.def -= def
            data.def += def
            addBattleLog(`星辰点亮，抢夺怪物50%防御`)
            }else if(randomNum(1,7) <= 1){
            let atk = data.battleMonster.atk * 0.5
            data.battleMonster.atk -= atk
            data.atk += atk
            addBattleLog(`星辰点亮，抢夺怪物50%攻击`)
            }else if(randomNum(1,7) <= 1){
            let suck = data.battleMonster.suck * 0.5
            data.battleMonster.suck -= suck
            data.suck += suck
            addBattleLog(`星辰点亮，抢夺怪物50%吸血`)
            }else if(randomNum(1,7) <= 1){
            addStatus(data, getStatus('恢复', {num : 3, addHp : 999}))
            addBattleLog(`星辰点亮，获得3次99恢复值的恢复效果`)
            }else if(randomNum(1,7) <= 1){
            addStatus(data.battleMonster, getStatus('封印', {keep : true, num : 1}))
            addBattleLog(`星辰点亮，给予怪物至臻封印`)
            }else if(randomNum(1,7) <= 1){
            addStatus(data.battleMonster, getStatus('眩晕', {num : 2}))
            addBattleLog(`星辰点亮，给予怪物眩晕`)
            }else if(randomNum(1,7) <= 1){
            addStatus(data, getStatus('复活'));
            addBattleLog(`星辰点亮，给予自身复活效果`)
            }
            return true;
        },
        text : '七颗星辰随机能力：抢夺防御，抢夺攻击，抢夺吸血，恢复血量，怪物封印，怪物眩晕，自身复活'
    }),
    '技能石：万生苏万生命' : new Element({
        battleUse : true,
        voidDust : 0,
        quality : 2,
        gold : 0,
        weight : 0,
        func : function(){
            if(!checkRace('万生苏万生命', true)){
                return false;
            }
            if(randomNum(1,100) <= 50){
            data.hp = data.maxHp;
            addBattleLog(`你使用了万生苏，血量回满了`)
            }else if(randomNum(1,100) <= 50){
            data.def += 500;
            data.battleMonster.def -= 500
            addBattleLog(`你使用了万生命，抢夺了怪物500防御`)
            }
            return true;
        },
        text : '随机万生苏或万生命 万生苏恢复所有血量，万生命抢夺500防御'
    }),
    '技能石：开源' : new Element({
        battleUse : true,
        voidDust : 0,
        quality : 1,
        gold : 0,
        weight : 0,
        func : function(){
            if(!checkRace('开源', true)){
                return false;
            }
            if(data.battleMonster.kyjn){
                winMsg(`你已经使用过一次了`, false, false);
                return false;
            }
            data.battleMonster.kyjn = true;
            data.reduceHart += 0.3;
            data.atk += data.atk;
            data.def += data.def;
            const text = `使用了开源，增加30%减伤，同时攻击和防御加倍`;
            addBattleLog(text)
            return true;
        },
        text : '增加30%减伤，攻击和防御加倍，只能使用一次'
    }),
    '技能石：吐息' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 0,
        endurance : 100,
        noSuck : true,
        voidDust : 0,
        quality : 1,
        gold : 0,
        preFunc : function(){
            if(!checkRace('吐息', true)){
                return false;
            }
            addStatus(data.battleMonster, getStatus('燃烧', {harm : data.level, num : 6}))
            return true;
        },
        myAtk : function(){
            return parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 2)
        },
        text : '龙族从小就会的本能攻击，攻击附带燃烧效果(燃烧伤害为自身等级)，伤害为攻击+武器攻击的2倍'
    }),
    '技能石：飞叶' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 0,
        endurance : 500,
        noSuck : true,
        voidDust : 0,
        quality : 1,
        atkNum : 2,
        gold : 0,
        preFunc : function(){
            if(!checkRace('飞叶', true)){
                return false;
            }
            return true;
        },
        myAtk : function(){
            return parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 0.5)
        },
        text : '龙-巫种族技能，攻击附带多重攻击效果(攻击次数为2)，伤害为攻击+武器攻击的0.5倍'
    }),
    '技能石：玄苍' : new Element({
        battleUse : true,
        voidDust : 20,
        quality : 1,
        weight : 0,
        gold : 50,
        func : function(){
            if(!checkRace('玄苍', true)){
                return false;
            }
            if(data.battleMonster.xc > 5){
                winMsg(`你已经使用过5次了`, false, false);
                return false;
            }
            if(!data.battleMonster.xc){
                data.battleMonster.xc = 1;
            }else{

                data.battleMonster.xc += 1;
            }
            data.shield += data.maxHp * 0.3;
            const text = `使用了玄苍，获得最大血量30%的护盾`;
            addBattleLog(text)
            return true;
        },
        text : '获得30%的护盾，一次战斗只能使用5次'
    }),
    '技能石：星陨' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 0,
        endurance : 1,
        noSuck : true,
        voidDust : 0,
        quality : 1,
        gold : 0,
        preFunc : function(){
            if(!checkRace('星陨', true)){
                return false;
            }
            MeteoriteFall()
            return true;
        },
        myAtk : function(){
            return 2147482856
        },
        text : '龙-巫皇种族技能，召唤天空陨石坠落大地，摧毁10×10以内除关卡BOSS外的所有地形，并对敌人造成2147482856伤害，若没有杀死敌人则核爆无效'
    }),
    '技能石：金行' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 0,
        endurance : 100,
        noSuck : true,
        voidDust : 0,
        quality : 1,
        gold : 0,
        preFunc : function(){
            if(!checkRace('金行', true)){
                return false;
            }
            if(!data.battleMonster.jx){
            data.reduceHart += 0.1;
            data.battleMonster.jx = true;
            }
            return true;
        },
        myAtk : function(){
            return parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 5)
        },
        text : '龙-五行种族技能，使用后增加10%减伤(一次)，攻击伤害为玩家攻击+武器攻击的5倍'
    }),
    '技能石：木行' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 0,
        endurance : 100,
        noSuck : true,
        voidDust : 0,
        quality : 1,
        gold : 0,
        preFunc : function(){
            if(!checkRace('木行', true)){
                return false;
            }
            addStatus(data, getStatus('恢复', {addHp : data.level, num : 6}))
            return true;
        },
        myAtk : function(){
            return parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 1.5)
        },
        text : '龙-五行种族技能，给予自身恢复效果(恢复量为自身等级)，并对敌人造成玩家攻击+武器攻击的1.5倍伤害'
    }),
    '技能石：水行' : new Element({
        canUse :true,
        battleUse : true,
        voidDust : 20,
        quality : 1,
        gold : 50,
        weight : 0,
        func : function(){
            if(!checkRace('水行', true)){
                return false;
            }
            let addHp = data.atk + (data.weapon ? data.weapon.getAtk(data.weapon) : 0)
            addHp *= 5;
            const text = `使用了水行，恢复${battleAddHp(data, addHp)}HP`;
            winMsg(text);
            addBattleLog(text)
            return true;
        },
        myHp : function(){
            return (data.atk + (data.weapon ? data.weapon.getAtk(data.weapon) : 0)) * 5;
        },
        text : '龙-五行种族技能，恢复相当于人物攻击力+装备攻击力5倍的的血量'
    }),
    '技能石：火行' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 0,
        endurance : 100,
        noSuck : true,
        voidDust : 0,
        quality : 1,
        gold : 0,
        preFunc : function(){
            if(!checkRace('火行', true)){
                return false;
            }
            addStatus(data.battleMonster, getStatus('燃烧', {harm : data.atk, num : 10}))
            return true;
        },
        myAtk : function(){
            return parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 8)
        },
        text : '龙-五行种族技能，对敌人造成自身攻击+武器攻击的8倍伤害，并对敌人附加燃烧效果(伤害为自身攻击)'
    }),
    '技能石：土行' : new Element({
        battleUse : true,
        voidDust : 20,
        quality : 1,
        gold : 50,
        func : function(){
            if(!checkRace('土行', true)){
                return false;
            }
            if(data.battleMonster.tx){
                winMsg(`你已经使用过一次了`, false, false);
                return false;
            }
            data.battleMonster.tx = true;
            data.reduceHart += 0.5;
            data.shield += data.maxHp * 5;
            const text = `使用了龙吟护盾，增加50%减伤，同时获得最大血量500%的护盾`;
            addBattleLog(text)
            return true;
        },
        text : '龙-五行种族技能，增加50%减伤，获得500%的护盾，只能使用一次'
    }),
    '技能石：金星' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 0,
        endurance : 100,
        noSuck : true,
        voidDust : 0,
        quality : 1,
        gold : 0,
        preFunc : function(){
            if(!checkRace('金星', true)){
                return false;
            }
            if(!data.battleMonster.jx){
            data.reduceHart += 0.1;
            data.battleMonster.jx = true;
            }
            return true;
        },
        myAtk : function(){
            return parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 500)
        },
        text : '龙-五星种族技能，使用后增加10%减伤(一次)，攻击伤害为玩家攻击+武器攻击的500倍'
    }),
    '技能石：木星' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 0,
        endurance : 100,
        noSuck : true,
        voidDust : 0,
        quality : 1,
        gold : 0,
        preFunc : function(){
            if(!checkRace('木星', true)){
                return false;
            }
            addStatus(data, getStatus('恢复', {addHp : data.atk * data.atk, num : 6}))
            return true;
        },
        myAtk : function(){
            return parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 150)
        },
        text : '龙-五星种族技能，给予自身恢复效果(恢复量为自身等级×等级)，并对敌人造成玩家攻击+武器攻击的150倍伤害'
    }),
    '技能石：水星' : new Element({
        canUse :true,
        battleUse : true,
        voidDust : 20,
        quality : 1,
        gold : 50,
        weight : 0,
        func : function(){
            if(!checkRace('水星', true)){
                return false;
            }
            let addHp = data.atk + (data.weapon ? data.weapon.getAtk(data.weapon) : 0)
            addHp *= 500;
            const text = `使用了水星，恢复${battleAddHp(data, addHp)}HP`;
            winMsg(text);
            addBattleLog(text)
            return true;
        },
        myHp : function(){
            return (data.atk + (data.weapon ? data.weapon.getAtk(data.weapon) : 0)) * 500;
        },
        text : '龙-五星种族技能，恢复相当于人物攻击力+装备攻击力500倍的的血量'
    }),
    '技能石：火星' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 0,
        endurance : 100,
        noSuck : true,
        voidDust : 0,
        quality : 1,
        gold : 0,
        preFunc : function(){
            if(!checkRace('火星', true)){
                return false;
            }
            addStatus(data.battleMonster, getStatus('燃烧', {harm : data.atk * data.atk, num : 1000}))
            return true;
        },
        myAtk : function(){
            return parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 800)
        },
        text : '龙-五星种族技能，对敌人造成自身攻击+武器攻击的800倍伤害，并对敌人附加燃烧效果(伤害为自身攻击×攻击)'
    }),
    '技能石：土星' : new Element({
        battleUse : true,
        voidDust : 20,
        quality : 1,
        gold : 50,
        weight : 0,
        func : function(){
            if(!checkRace('土星', true)){
                return false;
            }
            if(data.battleMonster.tx){
                winMsg(`你已经使用过一次了`, false, false);
                return false;
            }
            data.battleMonster.tx = true;
            data.reduceHart += 0.5;
            data.shield += data.maxHp * 500;
            const text = `使用了龙吟护盾，增加50%减伤，同时获得最大血量50000%的护盾`;
            addBattleLog(text)
            return true;
        },
        text : '龙-五星种族技能，增加50%减伤，获得50000%的护盾，只能使用一次'
    }),
    '技能石：呼啸的狂风' : new Element({
        canUse : true,
        weight : 0,
        voidDust : 0,
        func : function(){
            if(!checkRace('呼啸的狂风', true)){
                return false;
            }
            if(data.inDungeon){
                winMsg(`在副本中不可使用`, false, false);
                return false;
            }
            if(data.weapon.name !== '巫杖'){
                winMsg('你的没有携带巫杖', false, false)
                return false;
            }

            let monsterList = [
                ...data.world.mapElements[data.location.join()].monsterList,
            ];
            if(!data.inDungeon){
                const mapName = data.map[data.location[1]][data.location[0]];//地图名
                const point = data.location.join();//坐标
                monsterList = [
                    ...monsterList,
                    ...data.world.mythMonster.filter(e => e.location.join() === point && !e.deathTime).map(e => e.name),
                ];
                if(data.maps[data.worldIndex].endTerrain === mapName){
                    const name = data.maps[data.worldIndex].endBoss;
                    monsterList.push(name);
                }
                if(data.nextPoint && point === data.nextPoint.join()){
                    if(!data.world.pass){
                        monsterList.push(data.world.worldBoss);
                    }
                }
            }

            monsterList = monsterList.filter(e => data.zhc ? true : !monsterCfgs[e].noOneKill);
            data.zhc = false;
            if(monsterList.length > 0){
                let countHp = 0;
                monsterList.forEach(e => {
                    data.battleMonster = createBattleMonster(e);
                    countHp += data.battleMonster.hp * (monsterCfgs[e].noOneKill ? 10 : 1);
                    battleWin(true, 0, false);
                });

                let needEndurance = parseInt(countHp / 100) + (countHp % 500 === 0 ? 0 : 1);
                    if(needEndurance > 0){
                        let reduce = needEndurance;
                        if(data.weapon.endurance < reduce){
                            reduce = data.weapon.endurance;
                        }
                        reduceItemEndurance(data.weapon, reduce);
                        needEndurance -= reduce;
                    }
                if(needEndurance > 0){
                    data.hp -= needEndurance * 200;
                }
                if(data.hp <= 0){
                    winMsg('你强行呼唤狂风，被狂风碾碎')
                    $('.item-use-win-modal').hide();
                    $('.item-use-win').hide();
                    $('.bag').hide();
                    $('.home').hide();
                    addDieLog('你强行呼唤狂风，被狂风碾碎');
                    die();
                }else{
                    timeLapses(5)
                }
            }else{
                if(monsterList.length > 0){
                    winMsg('狂风无法对当前怪物造成伤害');
                }else{
                    winMsg('你找不到任何怪物');
                }
            }
            return true;
        },
        text : '龙-巫皇种族技能，必须武器是巫杖才能使用，在副本中不可使用。耗时5分钟，攻击并杀死当前看见的所有怪物（免疫即死攻击的怪物除外），怪物每有500血，便减少巫杖1点耐久。如果巫杖耐久度耗尽后，地图剩余的怪物还没全部杀死，那么则需要消耗玩家自身的血量来支付剩余需要消耗的耐久度，每200点血支付1点耐久度，如果你的血量不足以支撑使用，那么你就会被狂风碾碎'
    }),
    '技能石：破灭的山峰' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 0,
        endurance : 100,
        noSuck : true,
        voidDust : 0,
        quality : 1,
        gold : 0,
        preFunc : function(){
            if(!checkRace('破灭的山峰', true)){
                return false;
            }
            addStatus(data.battleMonster, getStatus('封印', {keep : true, num : 1, canAddNum : false}))
            return true;
        },
        myAtk : function(){
            return parseInt((data.atk + (data.weapon ? data.weapon.name.startsWith('技能石') ? 0 : data.weapon.getAtk(data.weapon) : 0)) * 50)
        },
        text : '龙-巫皇的种族技能，攻击附带至臻封印效果，伤害为攻击+武器攻击的50倍'
    }),
    '技能石：索命' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 0,
        endurance : 1,
        noSuck : true,
        voidDust : 0,
        quality : 1,
        gold : 0,
        preFunc : function(){
            if(!checkRace('索命', true)){
                return false;
            }
            return true;
        },
        myAtk : function(){
            return data.level * (parseInt(data.level / 10) +1) + ((data.battleMonster && data.battleMonster.maxHp > 0 ? data.battleMonster.maxHp : 0)) + ((data.battleMonster && data.battleMonster.def > 0 ? data.battleMonster.def : 0))
        },
        text : '龙-银龙王索命技能，伤害为怪物防御+怪物血量'
    }),
    '技能石：元素爆发' : new Element({
        onlyOne :true,
        isWeapon : true,
        weight : 0,
        endurance : 10,
        noSuck : true,
        voidDust : 0,
        quality : 1,
        gold : 0,
        preFunc : function(){
            if(!checkRace('元素爆发', true)){
                return false;
            }
           data.atk += 10;
            return true;
        },
        myAtk : function(){
            return data.atk * 3.5 + ((data.battleMonster && data.battleMonster.def > 0 ? data.battleMonster.def : 0))
        },
        text : '使用后增加10攻击，伤害为攻击的3.5倍，无视防御'
    }),
    '感染' : new Element({
     onlyOne : true,
     battleUse : true,
     quality : 1,
     weight : 0,
     voidDust : 0,
     func(){
            if(data.race.name !== '龙-灾厄'){
                winMsg('必须种族是龙-灾厄才能使用', false, false)
                return false;
            }
            if(this.monster){
                data.atk += this.monster.atk;
                data.def += this.monster.def;
                const text = `使用了${this.showName}，恢复${battleAddHp(data, this.monster.hp)}HP，攻击力+${this.monster.atk}，防御力+${this.monster.def}`;
                addBattleLog(text)
            }else{
                if(data.battleMonster.noOneKill){
                    winMsg('该怪物无法被感染', false, false);
                    return false;
                }
                if(data.inDungeon){
                    winMsg('不能在副本中使用', false, false);
                    return false;
                }
                if(data.level > data.battleMonster.level){
                    this.monster = data.battleMonster;
                    this.showName = `感染者：${this.monster.name}`;
                    msg(`感染${this.monster.name}成功`);
                    battleEnd();
                    setTimeout(function(){timeLapses(battleRunMin);},100)
                }else{
                    winMsg('需要自身等级大于怪物等级才可以感染')
                }
                return false;
            }
            return true;
        }, text : '龙-灾厄的技能 可以通过感染他人，让他人帮助自己战斗(需要自身等级大于怪物等级，才可以感染成功，否则无法感染，但无法感染神话怪)'}),
        '开源感染' : new Element({
     onlyOne : true,
     battleUse : true,
     quality : 1,
     weight : 0,
     voidDust : 0,
     func(){
            if(data.race.name !== '龙-灾厄神'){
                winMsg('必须种族是龙-灾厄神才能使用', false, false)
                return false;
            }
            if(this.monster){
                data.atk += this.monster.atk;
                data.def += this.monster.def;
                const text = `使用了${this.showName}，恢复${battleAddHp(data, this.monster.hp)}HP，攻击力+${this.monster.atk}，防御力+${this.monster.def}`;
                addBattleLog(text)
            }else{
                if(data.inDungeon){
                    winMsg('不能在副本中使用', false, false);
                    return false;
                }
                if(data.level > data.battleMonster.level){
                    this.monster = data.battleMonster;
                    this.showName = `感染者：${this.monster.name}`;
                    msg(`感染${this.monster.name}成功`);
                    battleEnd();
                    setTimeout(function(){timeLapses(battleRunMin);},100)
                }else{
                    winMsg('需要自身等级大于怪物等级才可以感染')
                }
                return false;
            }
            return true;
        }, text : '龙-灾厄神的技能 可以通过感染他人，让他人帮助自己战斗(需要自身等级大于怪物等级，才可以感染成功，否则无法感染)'}),

     //物品
     '巫杖' : new Element({onlyOne :true, isWeapon : true, washing : true, weight : 0, hole : 0, noWear : true, endurance : 1000, voidDust : 0, level : 2, quality : 0, gold : 0, myAtk : function(item){
            return 5
        }, text : '龙-巫妖的专属物品，可以用来支持技能释放'}),
        '灵剑' : new Element({onlyOne :true, isWeapon : true, weight : 50, hole : 0, endurance : 50000, voidDust : 0, level : -99999, quality : 3, gold : -999999, preFunc : function(item){
        data.battleMonster.hp -= data.level;
        addBattleLog(`对敌人造成${data.level}灵魂伤害`)
        return true;
        },
        myAtk : function(item){
            return 99
        }, text : '剑灵的专属武器，拥有99伤害，造成攻击时对敌人造成自身等级的真实伤害'}),
     '修复护符(神器)' : new Element({weight : 0, quality : 4, text : '蕴含着修复的力量，放在背包中可以为你修复你的武器装备(每次时间流逝+min)，效果无法叠加(除修复护符外)(由于无法叠加，且没有任何价值，所以不用搞什么外门邪道，无限制作，根本没有用)'}),
    '修复护符' : new Element({weight : 0, text : '蕴含着修复的力量，放在背包中可以为你修复你的武器装备(每次时间流逝+1)，效果无法叠加(除神器修复护符外)'}),
    '灵魂绑定' : new Element({onlyOne :true, quality : 3, canUse : true, func : function(item){
    data.bag.filter(e => {
    if(!e.saveOrder){
    e.saveOrder = true;
    }
        })
        return true;
        }, text : '将背包里的所有物品绑定于自身，使其不会因跳转周目而丢失'}),
    '奇异的石头' : new Element({onlyOne :true, quality : 2, canUse : true, func : function(item){
    if(data.world.name !== '神界'){
    winMsg(`似乎需要什么条件`)
    return false
    }
    says([
                `条件达成`,
                `石头发出奇异的光`,
                `隐约出现一抹模糊的身影`,
            ]);
    startBattle('伪神')
        return true;
        }, text : '一块发着光的石头，石身发出一些温度，不知道有什么用'}),
    '旧相片' : new Element({onlyOne :true, quality : 2, canUse : true, func : function(item){
    says([
                `Why！`,
                `Why are you showing me this!`,
                `Come on, run!`,
            ]);
    startBattle('SCP-096')
        return true;
        }, text : '一个旧相片，似乎是很久以前的物品了'}),
    //无限规则
    '无限·无穷物品' : new Element({weight : 0, rules : true, quality : 4, text : '特殊规则，当背包中有此规则时，背包所有物品(不包括物品，技能石，物品本身)数量变为无限'}),
    '无限·超级幸运' : new Element({weight : 0, rules : true, quality : 4, text : '特殊规则，当背包中有此规则时，自身幸运值变为999'}),
    //天赋
    '天赋：巧手' : new Element({weight : 0, rules : true, quality : 3, text : '玩家天赋，当背包中有此天赋时，所以的制作品材料-1(如果原版为1则不变)'}),
    '天赋：自护' : new Element({weight : 0, rules : true, quality : 3, text : '玩家天赋，当背包中有此天赋时，拥有一次致命伤害免疫'}),
};

//制作
const recipelzsj = {
'修复护符' : createRecipesCfg({'纤维' : 20,'神性结晶' : 2},1),
'修复护符(神器)' : createRecipesCfg({'修复护符' : 3,'神灵之力' : 1},1),
'灵魂绑定' : createRecipesCfg({'时空碎片' : 3000},1),
}

//龙族世界怪物
const monsterlz = {
    '伪神' : {
        tags : ['半神'],
        atkTime : '全天',
        atkProb : 0,
        level : 110,
        hp : 5600000,
        atk : 80000,
        def : 6000,
        exp : 231648284,
        atkSpd : 5,
        noOneKill : true,//免疫即死攻击
        type : '神话',
        items : [],
        text : '旧日的虚影，你不曾看见，祂不曾离去',
        skills : [{
            name : '混乱',
            type : 'start',
            text : '进入战斗时触发，给玩家附加混乱状态，攻击有概率混乱无法攻击，该状态无法被清除，同时属性增加玩家等级倍数',
            check : function(){return false},
            use : function(){
                addStatus(data, getStatus('混乱'))
                let m = data.battleMonster
                let l = data.level
                m.hp *= l
                m.maxHp *= l
                m.atk *= l
                m.def *= l
                addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了${this.name}，你被附加了混乱状态。`);
            },
        },{
                name : '千变万化',
                type : 'atk',
                text : '如你所见，吾即为所求',
                check : function(){return true},
                getStatus : function(){
                let r = randomNum(5,100)
                let m = data.battleMonster
                m.hp *= 2
                m.maxHp = m.oldAttrs.hp * r
                m.atk = m.oldAttrs.atk * r
                m.def = m.oldAttrs.def * r
                },
                getNum : function(){return data.battleMonster.atk + (data.def > 0 ? data.def : 0)},
            }
        ]
    },
    '尸鬼王' : {
        tags : ['半神'],
        atkTime : '全天',
        atkProb : 0,
        level : 100,
        hp : 56000,
        atk : 800,
        def : 60,
        exp : 2316484,
        atkSpd : 5,
        noOneKill : true,//免疫即死攻击
        type : '神话',
        items : [],
        text : '奇怪的存在',
        skills : [{
            name : '感染',
            type : 'start',
            text : '进入战斗时触发，给玩家附加病毒感染状态，回血量减少100%(部分技能无法减少)，并造成100伤害',
            check : function(){return false},
            use : function(){
                addStatus(data, getStatus('病毒感染'))
                addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了${this.name}，你被附加了病毒感染状态。`);
            },
        },{
                name : '尸爪',
                type : 'atk',
                text : '奇怪的东西，造成正常伤害并无视防御',
                check : function(){return true},
                use : function(){
                addStatus(data, getStatus('病毒感染'))
                },
                getNum : function(){return data.battleMonster.atk + (data.def > 0 ? data.def : 0)},
            }
        ]
    },
    '往墟君主' : {
        tags : ['半·神'],
        atkTime : '全天',
        atkProb : 0,
        level : 110,
        hp : 15000000,
        atk : 1500,
        def : 19900,
        suck : 500,
        exp : 0,
        atkSpd : 2,
        noOneKill : true,//免疫即死攻击
        type : '神话',
        items : [{name : '奇异的石头',minNum : -11111, maxNum : 1}],
        text : '黑暗之中的行者，往墟之中的神明，如此，凡者皆跪(在黑夜有1/1000000的概率出现)',
        skills : [{
            name : '往墟剑典',
            type : 'recover',
            text : '血量减少至50%时必然使用，使往墟君主变为真·神，并回复所有血量。该技能只会触发一次',
            check : function(){
                if(!data.battleMonster.wxjd && data.battleMonster.hp <= parseInt(data.battleMonster.maxHp * 0.5)){
        data.battleMonster.maxHp = parseInt(data.battleMonster.maxHp * 200)
        data.battleMonster.hp = parseInt(data.battleMonster.maxHp)
        data.battleMonster.atk = parseInt(data.battleMonster.atk * 200)
        data.battleMonster.def = parseInt(data.battleMonster.def * 200)
        addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了${this.name}，往墟归来之时，万物灭。全属性强化200倍`)
                        addStatus(data, getStatus('封印', {keep : true}));
                    data.battleMonster.wxjd = true;
                    data.battleMonster.showName = `${this.name}·${data.battleMonster.showName || data.battleMonster.name}`;
                    return true;
                }
                return false;
             }
         }]
    },
    '善恶天平之神' : {
        tags : ['神'],
        atkTime : '全天',
        atkProb : 0,
        level : 0,
        hp : 0,
        atk : 0,
        def : 0,
        suck : 0,
        exp : 0,
        atkSpd : 4,
        noOneKill : true,//免疫即死攻击
        type : '神话',
        items : [{name : '奇异的石头',minNum : -101121, maxNum : 1}],
        text : '传说中掌管善良与邪恶天平法则的神明，祂永远无法被真正杀死(当拥有邪恶时出现，如果邪恶值大于0，则每过一段时间就会出现一次)',
        skills : [{
                name : '善恶分明',
                type : 'atk',
                text : '对玩家造成邪恶值的强制伤害',
                check : function(){return true},
                getStatus : function(){
                data.hp -= data.evil
                addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了${this.name}，你的血量减少了${data.evil}`)
                },
                getNum : function(){return 0},
            },{
            name : '邪恶万恒',
            type : 'start',
            text : '自身属性变为玩家邪恶值',
            check : function(){return false},
            use : function(){
                let m = data.battleMonster
                m.maxHp = data.evil
                m.atk = data.evil
                m.def = data.evil
                m.level = data.evil
                m.hp = m.maxHp
                addBattleLog(`${data.battleMonster.showName || data.battleMonster.name}使用了${this.name}，血量，攻击，防御，等级变成了${data.evil}`)
             }
         }]
    },
    //scp基金会
    'SCP-096' : {
        tags : ['scp'],
        atkTime : '全天',
        atkProb : 0,
        level : 999,
        hp : 999999999999999999,
        atk : 99999999999999,
        def : 999999999999999,
        exp : 21474828569731,
        suck : 2000,
        notRun : true,
        type : null,
        noOneKill : true,
        InfiniteResurrection : 500,//复活次数
        UnableToSeal : true,//无法被封印
        UnableToVertigo : true,//无法眩晕
        text : '基金会生物，羞涩的人，不要看他的脸',
        items : [],
        skills : [{
                name : '攻击',
                type : 'atk',
                text : '造成正常伤害并无视防御',
                check : function(){return true},
                getNum : function(){return data.battleMonster.atk + (data.def > 0 ? data.def : 0)},
            }]
    },
}

//效果status
const lzsjstatus = {
    '混乱' : {
        name : '混乱',
        num : 1,
        type : 'buff',
        sleep : false,
        keep : true,
        canAddNum : false,
        text : '混乱不堪',
    },
    '病毒感染' : {
        name : '病毒感染',
        num : 1,
        sleep : false,
        keep : true,
        canAddNum : false,
        reduceRecover : 1,
        harm : 100,
        text : '发生了什么?',
    },
    '帝盾' : {
        name : '帝盾',
        num : 1,
        reduceHitRate : 100,
        sleep : false,
        keep : true,
        canAddNum : false,
        text : '无法对其造成伤害'
    },
}

//种族
const racelz = {
    '龙' : new Race({
        name : '龙',
        hunger : 500,
        water : 500,
        weight : 500,
        atk : 10,
        def : 5,
        hp : 1000,
        hpUp : 50,
        hungerUp : 10,
        waterUp : 10,
        weightUp : 20,
        atkUp : 1,
        defUp : 1,
        attrPoint : 3,
        atkSpd : 4,
        lzsja : 3,//3倍
        get : '自动解锁',
        skills : {
            '吐息' : createRecipesCfg({'肉' : 1}),
        },
        initItems : [{name : '观察之眼', num : 1}],
        text : '世界顶端的支配者，拥有巨大的翅膀，坚硬的鳞片以及锋利的利爪。作为一名龙族，请从现在开始，展现自己的骄傲，属于龙族的骄傲！龙族自带龙威效果，战斗中低于自身等级的生物，将对其造成3倍的伤害'
    }),
    '龙-银龙' : new Race({
        name : '龙-银龙',
        hunger : 500,
        water : 500,
        weight : 500,
        atk : 10,
        def : 5,
        hp : 800,
        hpUp : 50,
        hungerUp : 10,
        waterUp : 10,
        weightUp : 20,
        atkUp : 1,
        defUp : 1,
        attrPoint : 5,
        atkSpd : 5,
        lzsja : 1.5,//1.5倍
        get : '龙的一转',
        godRace : '龙-银龙王',//对应的2觉种族
        skills : {
            '龙吟护盾' : createRecipesCfg({'肉' : 1}),
            '吐息' : createRecipesCfg({'肉' : 1}),
            '元素爆发' : createRecipesCfg({'肉' : 10}),
        },
        text : '龙一次觉醒种族，专注于魔法的银龙拥有更强的魔法天赋。(龙威天赋变为1.5倍伤害，但是拥有更多魔法技能)'
    }),
    '龙-异种' : new Race({
        name : '龙-异种',
        hunger : 500,
        water : 500,
        weight : 800,
        atk : 8,
        def : 3,
        hp : 800,
        hpUp : 50,
        hungerUp : 10,
        waterUp : 10,
        weightUp : 20,
        atkUp : 1,
        defUp : 1,
        attrPoint : 5,
        atkSpd : 5,
        lzsja : 2,//2倍
        lzsjb : true,//无经验衰减
        get : '龙的一转扩展种族',
        godRace : '-1',//对应的2觉种族
        skills : {
            '吐息' : createRecipesCfg({'肉' : 1}),
        },
        text : '龙一次觉醒种族，因为特殊事件的发生，龙的基因出现了错误，变为了特殊性质的生物(龙威天赋：2倍;特殊天赋：无经验衰减)'
    }),
    '龙-时间' : new Race({
        name : '龙-时间',
        hunger : 500,
        water : 500,
        weight : 1000,
        atk : 9,
        def : 4,
        hp : 900,
        hpUp : 50,
        hungerUp : 10,
        waterUp : 10,
        weightUp : 50,
        atkUp : 2,
        defUp : 1,
        attrPoint : 6,
        atkSpd : 5,
        lzsja : 1.5,
        get : '龙的一转扩展种族',
        godRace : '龙-时空',//对应的2觉种族
        skills : {
            '吐息' : createRecipesCfg({'肉' : 1}),
            '时间回溯' : createRecipesCfg({'肉' : 10}),
            '时间之力' : createRecipesCfg({'肉' : 1}),
        },
        text : '龙一次觉醒种族，对时间有着一些理解，可以使用时间(龙威天赋：1.5倍)'
    }),
    '龙-空间' : new Race({
        name : '龙-空间',
        hunger : 500,
        water : 500,
        weight : 1000,
        atk : 9,
        def : 4,
        hp : 900,
        hpUp : 50,
        hungerUp : 10,
        waterUp : 10,
        weightUp : 50,
        atkUp : 2,
        defUp : 1,
        attrPoint : 6,
        atkSpd : 5,
        lzsja : 1.5,
        get : '龙的一转扩展种族',
        godRace : '龙-时空',//对应的2觉种族
        skills : {
            '吐息' : createRecipesCfg({'肉' : 1}),
            '空间折叠' : createRecipesCfg({'肉' : 1}),
            '空间之力' : createRecipesCfg({'肉' : 1}),
        },
        text : '龙一次觉醒种族，对空间有着一些理解，可以使用空间(龙威天赋：1.5倍)'
    }),
    '龙-五行' : new Race({
        name : '龙-五行',
        hunger : 0,
        water : 0,
        weight : 800,
        atk : 11,
        def : 4,
        hp : 850,
        hpUp : 50,
        hungerUp : 10,
        waterUp : 10,
        weightUp : 20,
        atkUp : 1,
        defUp : 1,
        attrPoint : 5,
        atkSpd : 5,
        noHunger : true,
        lzsja : 5,//5倍
        get : '龙的一转扩展种族',
        godRace : '龙-五星',//对应的2觉种族
        skills : {
            '火行' : createRecipesCfg({'肉' : 2}),
            '吐息' : createRecipesCfg({'肉' : 1}),
            '土行' : createRecipesCfg({'肉' : 2}),
            '金行' : createRecipesCfg({'肉' : 2}),
            '木行' : createRecipesCfg({'肉' : 2}),
            '水行' : createRecipesCfg({'肉' : 2}),
        },
        text : '龙一次觉醒种族，专注于五行的龙拥有更强的五行魔法天赋。(龙威天赋变为5倍伤害，拥有更多魔法技能)'
    }),
    '龙-灾厄' : new Race({
        name : '龙-灾厄',
        hunger : 500,
        water : 500,
        weight : 500,
        atk : 10,
        def : 5,
        hp : 750,
        hpUp : 50,
        hungerUp : 10,
        waterUp : 10,
        weightUp : 20,
        atkUp : 1,
        defUp : 1,
        attrPoint : 5,
        atkSpd : 5,
        get : '龙的一转',
        godRace : '龙-灾厄神',//对应的2觉种族
        skills : {
            '吐息' : createRecipesCfg({'肉' : 1}),
        },
        recipes : {
            '感染' : createRecipesCfg({'肉' : 5}),
        },
        text : '龙一次觉醒种族，因为不知名原因产生了异变，肉体丧失。(龙威天赋不再存在，但是可以通过吞噬他人恢复血量)'
    }),
    '龙-金龙' : new Race({
        name : '龙-金龙',
        hunger : 500,
        water : 500,
        weight : 500,
        atk : 10,
        def : 5,
        hp : 2000,
        hpUp : 50,
        hungerUp : 10,
        waterUp : 10,
        attrPoint : 5,
        atkUp : 3,
        defUp : 3,
        weightUp : 50,
        atkSpd : 5,
        lzsja : 10,//10倍
        get : '龙的一转',
        skills : {
            '吐息' : createRecipesCfg({'肉' : 1}),
        },
        godRace : '龙-金龙王',//对应的2觉种族
        text : '龙一次觉醒种族，专注于肉体的磨练，拥有更强大的肉体力量。(龙威效果变为10倍伤害)'
    }),
    '龙-巫' : new Race({
        name : '龙-巫',
        hunger : 400,
        water : 400,
        weight : 800,
        atk : 8,
        def : 3,
        hp : 600,
        hpUp : 50,
        hungerUp : 10,
        waterUp : 10,
        weightUp : 20,
        atkUp : 1,
        defUp : 1,
        attrPoint : 5,
        atkSpd : 5,
        get : '龙的一转扩展种族',
        godRace : '龙-巫皇',//对应的2觉种族
        skills : {
            '吐息' : createRecipesCfg({'肉' : 1}),
            '飞叶' : createRecipesCfg({'肉' : 1}),
            '玄苍' : createRecipesCfg({'肉' : 5}),
        },
        recipes : {
            '巫杖' : createRecipesCfg({'木材' : 5, '纯净水晶' : 1}),
        },
        text : '龙一次觉醒种族，因为偷学巫族能力，所以会使用巫族的力量。(但是龙威天赋不再)'
    }),
    '龙-金龙王' : new Race({
        name : '龙-金龙王',
        hunger : 5000,
        water : 5000,
        weight : 50000,
        atk : 50,
        def : 25,
        hp : 20000,
        hpUp : 500,
        hungerUp : 500,
        waterUp : 500,
        attrPoint : 10,
        atkUp : 8,
        defUp : 8,
        weightUp : 500,
        lzsja : 50,//50倍
        atkSpd : 6,
        get : '由龙-金龙通过神灵之力转职而得',
        skills : {
            '吐息' : createRecipesCfg({'肉' : 1}),
        },
        text : '专注于肉体的磨练，拥有最为强大的肉体力量。(龙威效果变为50倍伤害)'
    }),
    '龙-银龙王' : new Race({
        name : '龙-银龙王',
        hunger : 5000,
        water : 5000,
        weight : 5000,
        atk : 20,
        def : 10,
        hp : 8000,
        hpUp : 50,
        hungerUp : 100,
        waterUp : 100,
        weightUp : 200,
        atkUp : 3,
        defUp : 3,
        attrPoint : 10,
        atkSpd : 5,
        lzsja : 1.5,
        get : '由龙-银龙通过神灵之力转职而得',
        skills : {
            '龙吟护盾' : createRecipesCfg({'肉' : 1}),
            '吐息' : createRecipesCfg({'肉' : 1}),
            '元素爆发' : createRecipesCfg({'肉' : 10}),
            '星辰七连' : createRecipesCfg({'肉' : 20}),
            '万生苏万生命' : createRecipesCfg({'肉' : 20}),
            '索命' : createRecipesCfg({'肉' : 3000}),
        },
        text : '专注于魔法的银龙拥有更强的魔法天赋。(魔法技能在之前的基础上增加更多)'
    }),
    '龙-巫皇' : new Race({
        name : '龙-巫皇',
        hunger : 5000,
        water : 5000,
        weight : 5000,
        atk : 20,
        def : 10,
        hp : 8000,
        hpUp : 50,
        hungerUp : 100,
        waterUp : 100,
        weightUp : 200,
        atkUp : 3,
        defUp : 3,
        attrPoint : 10,
        atkSpd : 6,
        get : '由龙-巫通过神灵之力转职而得',
        skills : {
            '飞叶' : createRecipesCfg({'肉' : 1}),
            '吐息' : createRecipesCfg({'肉' : 1}),
            '玄苍' : createRecipesCfg({'肉' : 1}),
            '星陨' : createRecipesCfg({'肉' : 2000}),
            '呼啸的狂风' : createRecipesCfg({'肉' : 200}),
            '破灭的山峰' : createRecipesCfg({'肉' : 300}),
        },
        text : '拥有更为强大实力的巫族龙，巫术达到超强，但龙威的天赋能力却也消失不见'
    }),
    '龙-五星' : new Race({
        name : '龙-五星',
        hunger : 0,
        water : 0,
        weight : 0,
        atk : 20,
        def : 10,
        hp : 8500,
        hpUp : 50,
        hungerUp : 100,
        waterUp : 100,
        weightUp : 200,
        atkUp : 3,
        defUp : 3,
        attrPoint : 10,
        atkSpd : 5,
        noHunger : true,
        lzsja : 6,
        get : '由龙-五行通过神灵之力转职而得',
        skills : {
            '金星' : createRecipesCfg({'肉' : 2}),
            '木星' : createRecipesCfg({'肉' : 2}),
            '水星' : createRecipesCfg({'肉' : 2}),
            '火星' : createRecipesCfg({'肉' : 2}),
            '土星' : createRecipesCfg({'肉' : 2}),
            '吐息' : createRecipesCfg({'肉' : 1}),
        },
        text : '专注于五行魔法的五行龙拥有更强的实力，对五行有了更深的理解，只是……似乎理解歪了。(龙威天赋：6倍)'
    }),
    '龙-灾厄神' : new Race({
        name : '龙-灾厄神',
        hunger : 1000,
        water : 1000,
        weight : 5000,
        atk : 30,
        def : 15,
        hp : 7050,
        hpUp : 80,
        hungerUp : 10,
        waterUp : 10,
        weightUp : 50,
        atkUp : 8,
        defUp : 6,
        attrPoint : 10,
        atkSpd : 5,
        get : '由龙-灾厄通过神灵之力转职而得',
        skills : {
            '吐息' : createRecipesCfg({'肉' : 1}),
            '开源' : createRecipesCfg({'肉' : 10})
        },
        recipes : {
            '开源感染' : createRecipesCfg({'肉' : 1}),
        },
        text : '龙-灾厄的觉醒种族，因为不知名原因产生了异变，肉体丧失，却因强大的力量成为神明(龙威天赋不再存在，但是可以通过吞噬他人恢复血量，作为神明，你拥有一次复活机会)'
    }),
    '龙-时空' : new Race({
        name : '龙-时空',
        hunger : 1000,
        water : 1000,
        weight : 8000,
        atk : 10,
        def : 9,
        hp : 9999,
        hpUp : 50,
        hungerUp : 10,
        waterUp : 10,
        weightUp : 50,
        atkUp : 2,
        defUp : 1,
        attrPoint : 6,
        atkSpd : 6,
        lzsja : 8,
        get : '龙-空间或龙-时间使用神灵之力获得',
        skills : {
            '吐息' : createRecipesCfg({'肉' : 1}),
            '时间回溯' : createRecipesCfg({'肉' : 10}),
            '时空之力' : createRecipesCfg({'肉' : 1}),
            '空间折叠' : createRecipesCfg({'肉' : 1}),
        },
        text : '龙二次觉醒种族，对时间和空间有着一定理解，可以使用时间和空间的力量，极强(龙威天赋：8倍)'
    }),
    '剑灵' : new Race({
        name : '剑灵',
        hunger : 0,
        water :  0,
        weight : 9999,
        atk : 1,
        def : 1,
        hp : 100,
        hpUp : 0,
        hungerUp : 0,
        waterUp : 0,
        weightUp : 0,
        atkUp : 0,
        defUp : 0,
        attrPoint : 0,
        atkSpd : 6,
        noHunger : true,
        lzsjzdhx : 0.1,//自动回血，0.1hp/min
        get : '自动解锁',
        skills : {
            '人剑合一' : createRecipesCfg({}),
            '斩天' : createRecipesCfg({}),
        },
        recipes : {
            '灵剑' : createRecipesCfg({}),
        },
        text : '万剑齐聚，以剑开天！万物终结，以剑证道！'
    }),
    //龙族扩展
    '星空灵魂' : new Race({
        name : '星空灵魂',
        hunger : 999999,
        water : 999999,
        weight : 2147482856,
        atk : 9999,
        def : 9999,
        hp : 99999999,
        hpUp : 99999,
        hungerUp : 99999,
        waterUp : 99999,
        weightUp : 99999,
        atkUp : 99999,
        defUp : 99999,
        attrPoint : 1000,
        atkSpd : 8,
        lzsjkzzz : true,
        get : '扩展难度自动解锁',
        skills : {
            '星空' : createRecipesCfg({}),
            '黄土守护' : createRecipesCfg({}),
            '真灵呼唤' : createRecipesCfg({}),
        },
        text : '虚空之下，万物苍生归芽。何时能眺望整个星空，成就最后的单纯'
    }),
};

//将自定义生物加入怪物列表
function addMonsterLZ(){
    Object.keys(monsterlz).forEach(name => {
        const {skills = [], ...props} = monsterlz[name];

        monsterCfgs[name] = props;
        monsterSkillMapping[name] = [];

        skills.forEach(s => {
            if(typeof s === 'string'){
                monsterSkillMapping[name].push(s);
            }else{
                monsterSkillMapping[name].push(s.name);

                if(s.extend){
                    monsterSkills = {
                        ...monsterSkills,
                        [s.name] : {
                            ...monsterSkills[s.extend],
                            name : s.name,
                        }
                    }
                }else{
                    monsterSkills = {
                        ...monsterSkills,
                        [s.name] : s
                    }
                }
            }
        });
    });
}

//陨石坠落
function MeteoriteFall(){
    //获取到所有有效坐标
    const points = [];
    const [xp, yp] = data.location;
    for(let x = -10 ; x <= 10 ; x++){
        for(let y = -10 ; y <= 10 ; y++){
            const thisx = xp + x;
            const thisy = yp + y;
            if(thisx >= 0 && thisx < xnum && thisy >= 0 && thisy < xnum && (!data.nextPoint || `${thisx},${thisy}` !== data.nextPoint.join()) && (!data.prePoint || `${thisx},${thisy}` !== data.prePoint.join())){
                points.push([thisx,thisy])
            }
        }
    }

    let log = `陨石坠落大地，摧毁了${points.length}个地形`;

    //循环销毁地形
    points.forEach(e => {
        //摧毁神殿
        if(data.temples[data.worldIndex][e.join()]){
            log += `，${data.temples[data.worldIndex][e.join()].name}被摧毁了`;
            delete data.temples[data.worldIndex][e.join()];
        }
        //杀死神话怪
        const myths = data.world.mythMonster.filter(m => m.location.join() === e.join());
        if(myths.length > 0){
            myths.forEach(m => {
                log += `，${m.name}被杀死了`;
                m.deathTime = new Date(data.date).getTime();
            })
        }
        //杀死NPC
        if(data.world.npcs){
            data.world.npcs.filter(n => n.location.join() === e.join()).forEach(n => {
                log += `，${n.name}被杀死了`;
            })
            data.world.npcs = data.world.npcs.filter(n => n.location.join() !== e.join())
        }
        //摧毁家
        if(data.world.home.location.join() === e.join()){
            log += '，你的家被摧毁了';
            data.world.home = {
                location : [],
                store : [],
            }
        }
        //摧毁地形
        data.map[e[1]][e[0]] = '废土';
        data.world.map[e[1]][e[0]] = '废土';
        data.world.mapElements[e.join()] = {
            elementList : [],
            monsterList : [],
            renderDates : {}
        }
    })

    winMsg(log);
    addBattleLog(log)
    renderMapElements(false, true)
    renderCanToMap();
}